



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>(luogu4180) [Beijing2010组队]次小生成树Tree</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">(luogu4180) [Beijing2010组队]次小生成树Tree</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 09:12:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>严格次小生成树</strong></p>
<p>首先看看如果不严格我们怎么办。</p>
<p><a href="https://zhuanlan.zhihu.com/p/24950356" rel="external nofollow noreferrer">非严格次小生成树怎么做</a></p>
<p>由此，我们发现一个结论，求非严格次小生成树，只需要先用kruskal算法求得最小生成树，然后暴力枚举非树边，替换路径最大边即可。</p>
<p>那要是严格呢？</p>
<p>我们发现如果是严格的次小生成树，那么将一条边替换另一条时，这两条边的权值一定<strong>不相同</strong></p>
<p>但是，我们知道，<strong>替换边</strong>肯定大于等于<strong>被替换边</strong>（因为如果<strong>替换边</strong>小于<strong>被替换边</strong>，就存在一颗包含<strong>替换边</strong>而不包含<strong>被替换边</strong>的一棵权值更小的生成树，原树就不是最小生成树了）</p>
<p>所以替换边要么等于路径上最大的边，要么比最大的边还大。</p>
<p>利用这个性质，我们只需要维护路径中的最大值和次大值，当<strong>替换边</strong>等于路径上的最大值，我们直接换用严格次大值即可。</p>
<p><strong>一些细节</strong></p>
<p>1.我维护两点之间路径最大值用的是LCT，但是正解是LCA。LCT必须要开O2才能跑过去。</p>
<p>2.数组要开足够大，最后统计答案时要开long long,不然会爆int</p>
<p><strong>我的代码</strong></p>
<pre class="prettyprint linenums"><code>#include &lt;algorithm&gt;<br />
#include &lt;iostream&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;cstdio&gt;<br />
#include &lt;vector&gt;<br />
#include &lt;queue&gt;<br />
#define rg register int<br />
#define ll long long<br />
#define RG register<br />
#define il inline<br />
using namespace std;

il ll gi() {<br />
    RG ll x=0;rg o=0;RG char ch=getchar();<br />
    while(ch!='-'&amp;&amp;(ch&lt;'0'||'9'&lt;ch)) ch=getchar();<br />
    if(ch=='-') o=1,ch=getchar();<br />
    while('0'&lt;=ch&amp;&amp;ch&lt;='9') x=(x&lt;&lt;1)+(x&lt;&lt;3)+ch-'0',ch=getchar();<br />
    return o?-x:x;<br />
}<br />
int n,m;<br />
#define SZ 7000010

struct Edge {int a,b;ll w;}e[SZ];<br />
bool cmp(Edge a,Edge b) {return a.w&lt;b.w;}

#define lson tr[x].ch[0]<br />
#define rson tr[x].ch[1]<br />
struct Splaytree{int fa,ch[2],rev,mxp,mxp2;}tr[SZ];<br />
il void pushup(rg x)<br />
{<br />
    tr[x].mxp=x; tr[x].mxp2=0;<br />
    if(e[tr[lson].mxp].w&gt;e[tr[x].mxp].w) tr[x].mxp=tr[lson].mxp;<br />
    if(e[tr[rson].mxp].w&gt;e[tr[x].mxp].w) tr[x].mxp=tr[rson].mxp;<br />
    // 维护 最大<br />
    if(e[tr[lson].mxp].w!=e[tr[x].mxp].w &amp;&amp; (e[tr[lson].mxp].w&gt;e[tr[x].mxp].w||!tr[x].mxp2) ) tr[x].mxp2=tr[lson].mxp;<br />
    if(e[tr[lson].mxp2].w!=e[tr[x].mxp].w &amp;&amp; (e[tr[lson].mxp2].w&gt;e[tr[x].mxp].w||!tr[x].mxp2) ) tr[x].mxp2=tr[lson].mxp2;<br />
    if(e[tr[rson].mxp].w!=e[tr[x].mxp].w &amp;&amp; (e[tr[rson].mxp].w&gt;e[tr[x].mxp].w||!tr[x].mxp2) ) tr[x].mxp2=tr[rson].mxp;<br />
    if(e[tr[rson].mxp2].w!=e[tr[x].mxp].w &amp;&amp; (e[tr[rson].mxp2].w&gt;e[tr[x].mxp].w||!tr[x].mxp2) ) tr[x].mxp2=tr[rson].mxp2;<br />
    // 维护严格次大<br />
}<br />
il void pushdown(rg x)<br />
{<br />
    if(tr[x].rev)<br />
    {<br />
        tr[lson].rev^=1,tr[rson].rev^=1;<br />
        swap(lson,rson),tr[x].rev=0;<br />
    }<br />
}<br />
il bool isroot(rg x)<br />
{<br />
    return tr[tr[x].fa].ch[0]!=x &amp;&amp; tr[tr[x].fa].ch[1]!=x;<br />
}<br />
il void rotate(rg x)<br />
{<br />
    rg y=tr[x].fa,z=tr[y].fa;<br />
    rg k=tr[y].ch[1]==x;<br />
    if(!isroot(y)) tr[z].ch[y==tr[z].ch[1]]=x;tr[x].fa=z;<br />
    tr[y].ch[k]=tr[x].ch[k^1],tr[tr[x].ch[k^1]].fa=y;<br />
    tr[x].ch[k^1]=y,tr[y].fa=x;<br />
    pushup(y),pushup(x);<br />
}<br />
int stk[SZ],top;<br />
il void splay(rg x)<br />
{<br />
    stk[top=1]=x;<br />
    for(rg i=x;!isroot(i);i=tr[i].fa) stk[++top]=tr[i].fa;<br />
    for(;top;--top) pushdown(stk[top]);<br />
    while(!isroot(x))<br />
    {<br />
        rg y=tr[x].fa,z=tr[y].fa;<br />
        if(!isroot(y))<br />
         (tr[y].ch[0]==x)^(tr[z].ch[0]==y)?rotate(x):rotate(y);<br />
        rotate(x);<br />
    }<br />
}<br />
il void access(rg x) {for(rg y=0;x;y=x,x=tr[x].fa)splay(x),rson=y,pushup(x);}<br />
il void makeroot(rg x) {access(x);splay(x);tr[x].rev^=1;}<br />
il int findroot(rg x) {access(x);splay(x);while(lson) x=lson;return x;}<br />
il void split(rg x,rg y) {makeroot(x);access(y);splay(y);}<br />
il int query(rg x,rg y) {split(x,y);return tr[y].mxp;} //求x 到 y最大值<br />
il int query2(rg x,rg y) {split(x,y);return tr[y].mxp2;} // 求x 到 y严格次大值<br />
il void link(rg x,rg y) {makeroot(x);tr[x].fa=y;}<br />
il void cut(rg x,rg y) {split(x,y);if(tr[y].ch[0]==x)tr[y].ch[0]=tr[x].fa=0;}<br />
int fa[SZ];int find_fa(rg x) {if(x!=fa[x]) fa[x]=find_fa(fa[x]);return fa[x];} //一行并查集<br />
bool check[SZ];

int main()<br />
{

    n=gi(),m=gi();<br />
    for(rg i=1;i&lt;=m;++i) e[i]=(Edge){gi(),gi(),gi()};<br />
    // 先求一遍最小生成树 ans 记录最小生成树边的大小<br />
    RG ll ans=0;<br />
    sort(e+1,e+1+m,cmp);<br />
    for(rg i=1;i&lt;=n;++i) fa[i]=i; // 初始化并查集<br />
    for(rg f1,f2,i=1;i&lt;=m;++i)<br />
    {<br />
        f1=find_fa(e[i].a);<br />
        f2=find_fa(e[i].b);<br />
        if(f1!=f2)<br />
        {<br />
            check[i]=1; // check=1 表示最小生成树中有这一条边 反之<br />
            fa[f1]=f2;<br />
            ans+=e[i].w;<br />
            link(e[i].a+m,i);<br />
            link(e[i].b+m,i);<br />
        }<br />
    }

#define INF 2147483647<br />
#define Getmin(a,b) (a)=(a)&gt;(b)?(b):(a) 

    RG ll Ans=INF;<br />
    for(rg f1,f2,i=1;i&lt;=m;++i)<br />
    {<br />
        if(check[i]) continue; //我们选择不再最小生成树上的边<br />
        rg mxp=query(e[i].a+m,e[i].b+m);<br />
        if(e[mxp].w==e[i].w)<br />
        {<br />
            rg mxp2=query2(e[i].a+m,e[i].b+m);<br />
            if(!mxp2 || e[mxp2].w==e[mxp].w) continue;<br />
            Getmin(Ans,e[i].w-e[mxp2].w);<br />
        }<br />
        else Getmin(Ans,e[i].w-e[mxp].w);<br />
    }

    cout&lt;&lt;ans+Ans;<br />
    return 0;<br />
}

</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kl6y7q.html">&lbrack;20160707&rsqb;Java中如何关闭Frame窗口</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e15e0z9.html">Mysql使用大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yn63jq.html">JavaScript--基本包装类型&lpar;13&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ve57o8.html">C&num; 中 datagridview 绑定BindingList类型和更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ozdyj9.html">poj3249</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x26e08.html">avalon2学习心得（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmydj19.html">顺便说一下&dollar;&period;each&lpar;&rpar;函数&colon;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgw7j78.html">CentOS 7 学习（一） 配置LAMP和Nginx</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdv2yk9.html">OC学习6&mdash;&mdash;面相对象的三大特性</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzyo2e8.html">php通过pecl方式安装扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gm27mq.html">code forces 805B &lpar;水&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o14ox8.html">【Linux】-NO&period;9&period;Linux&period;5&period;Nexus&period;1&period;001-【CentOS 7 Install Nexus 3&period;3】-</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ro4m39.html">IntelliJ IDEA 2017版 Spring5 java&period;lang&period;NoSuchMethodError&colon; org&period;springframework&period;boot&period;SpringApplication&period;&amp;lt&semi;init&amp;gt&semi;&lpar;&lbrack;Ljava&sol;lang&sol;Object&semi;&rpar;V</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp1one9.html">struts2中的方法的调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjwmvr8.html">mysql  不同事务隔离级别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp7j149.html">c&num;基础学习&lpar;0702&rpar;之面向对象和方法重写概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/9024k1nq.html">使用Spring操作Redis的key-value数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvejpnz9.html">Python学习---IO的异步&lbrack;自定义异步IO&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl2dzl9.html">一类划分关系和指数级生成函数，多项式exp的关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e6e419.html">第2章-Vue&period;js指令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj2mjx9.html">利用UICollectionView实现列表和宫格视图的切换</a>
			</li>
						<li><a href="https://www.batexi.com/a/950v0kv8.html">JavaScript 中的对象深度复制&lpar;Object Deep Clone&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzr1ml8.html">使用域账号统一管理cisco网络设备</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2lnx9.html">面试陷阱1：Integer类型的比较</a>
			</li>
						<li><a href="https://www.batexi.com/a/950vgj08.html">Mysql数据库查询不区分大小写解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj215x9.html">前端构建工具之gulp的安装和配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/950vp1z8.html">MySql全国省市区SQL语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1oz3yq.html">spring-boo hello world程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojwv7lq.html">计蒜客 取数游戏 博弈&plus;dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jn2kx8.html">kibana常用聚合查询DSL语句记录</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
